# Copyright 2016 the V8 project authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

{
  'variables': {
    'inspector_generated_sources': [
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/Forward.h',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/Protocol.cpp',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/Protocol.h',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/Console.cpp',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/Console.h',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/Debugger.cpp',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/Debugger.h',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/HeapProfiler.cpp',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/HeapProfiler.h',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/Profiler.cpp',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/Profiler.h',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/Runtime.cpp',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/Runtime.h',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/Schema.cpp',
      '<(SHARED_INTERMEDIATE_DIR)/src/inspector/protocol/Schema.h',
      '<(SHARED_INTERMEDIATE_DIR)/include/inspector/Debugger.h',
      '<(SHARED_INTERMEDIATE_DIR)/include/inspector/Runtime.h',
      '<(SHARED_INTERMEDIATE_DIR)/include/inspector/Schema.h',
    ],

    'inspector_injected_script_source': 'InjectedScriptSource.js',
    'inspector_generated_injected_script': '<(SHARED_INTERMEDIATE_DIR)/src/inspector/InjectedScriptSource.h',
    'inspector_debugger_script_source': 'DebuggerScript.js',
    'inspector_generated_debugger_script': '<(SHARED_INTERMEDIATE_DIR)/src/inspector/DebuggerScript.h',

    'inspector_all_sources': [
      '<@(inspector_generated_sources)',
      '<(inspector_generated_injected_script)',
      '<(inspector_generated_debugger_script)',
      '../../include/v8-inspector.h',
      '../../include/v8-inspector-protocol.h',
      'inspector/Allocator.h',
      'inspector/InjectedScript.cpp',
      'inspector/InjectedScript.h',
      'inspector/InjectedScriptNative.cpp',
      'inspector/InjectedScriptNative.h',
      'inspector/InspectedContext.cpp',
      'inspector/InspectedContext.h',
      'inspector/JavaScriptCallFrame.cpp',
      'inspector/JavaScriptCallFrame.h',
      'inspector/ProtocolPlatform.h',
      'inspector/RemoteObjectId.cpp',
      'inspector/RemoteObjectId.h',
      'inspector/ScriptBreakpoint.h',
      'inspector/SearchUtil.cpp',
      'inspector/SearchUtil.h',
      'inspector/String16.cpp',
      'inspector/String16.h',
      'inspector/StringUtil.cpp',
      'inspector/StringUtil.h',
      'inspector/V8Console.cpp',
      'inspector/V8Console.h',
      'inspector/V8ConsoleAgentImpl.cpp',
      'inspector/V8ConsoleAgentImpl.h',
      'inspector/V8ConsoleMessage.cpp',
      'inspector/V8ConsoleMessage.h',
      'inspector/V8Debugger.cpp',
      'inspector/V8Debugger.h',
      'inspector/V8DebuggerAgentImpl.cpp',
      'inspector/V8DebuggerAgentImpl.h',
      'inspector/V8DebuggerScript.cpp',
      'inspector/V8DebuggerScript.h',
      'inspector/V8FunctionCall.cpp',
      'inspector/V8FunctionCall.h',
      'inspector/V8HeapProfilerAgentImpl.cpp',
      'inspector/V8HeapProfilerAgentImpl.h',
      'inspector/V8InjectedScriptHost.cpp',
      'inspector/V8InjectedScriptHost.h',
      'inspector/V8InspectorImpl.cpp',
      'inspector/V8InspectorImpl.h',
      'inspector/V8InspectorSessionImpl.cpp',
      'inspector/V8InspectorSessionImpl.h',
      'inspector/V8InternalValueType.cpp',
      'inspector/V8InternalValueType.h',
      'inspector/V8ProfilerAgentImpl.cpp',
      'inspector/V8ProfilerAgentImpl.h',
      'inspector/V8Regex.cpp',
      'inspector/V8Regex.h',
      'inspector/V8RuntimeAgentImpl.cpp',
      'inspector/V8RuntimeAgentImpl.h',
      'inspector/V8SchemaAgentImpl.cpp',
      'inspector/V8SchemaAgentImpl.h',
      'inspector/V8StackTraceImpl.cpp',
      'inspector/V8StackTraceImpl.h',
      'inspector/V8ValueCopier.cpp',
      'inspector/V8ValueCopier.h',
    ]
  }
}
